//gcc -o ascii ascii.c -I/opt/local/include/libftdi1 -L/opt/local/lib -lftdi1
#include <math.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <ftdi.h>
#include <unistd.h>

int main(int argc, char *argv[]){

        int i;
        int BytesWritten;
        int BytesRead;

	unsigned char *TxBuffer;
	unsigned char *RxBuffer;
        TxBuffer = (char *) malloc(1 * sizeof(char));
        RxBuffer = (char *) malloc(7 * sizeof(char));

	char FTDIbuf[256];
	struct ftdi_context *ftdi;
	ftdi = ftdi_new();
	sprintf(FTDIbuf, "s:0x0403:0x6001:487V");
	ftdi_usb_open_string(ftdi, FTDIbuf);

        TxBuffer = "?D1\x00\x00\x00\x00\r";
	BytesWritten = ftdi_write_data(ftdi, TxBuffer, 8);
        sleep(2);
        BytesRead = ftdi_read_data(ftdi, RxBuffer, 56);

        int lsb = RxBuffer[2];
        int msb = RxBuffer[3];
        int countvalue = lsb+(msb<<8);
        if(msb>>7){
          countvalue = countvalue - 65536;
        }
        double RMAX;
        double CAL;
        int rng_bit = (RxBuffer[6]&0xE0)>>5;
        if(rng_bit == 1) RMAX = 200*0.000001;
        if(rng_bit == 2) RMAX =   2*0.001;
        if(rng_bit == 3) RMAX =  20*0.001;
        if(rng_bit == 4) RMAX = 200*0.001;

        int CAL100 = (RxBuffer[6]&0xF);
        int CAL010 = (RxBuffer[5]&0xF0) >> 4;
        int CAL001 = (RxBuffer[5]&0xF);
        int CALSGN = (RxBuffer[6]&0x10);
        if(CALSGN)
           CAL = -1*(10.*CAL100+1.*CAL010+0.1*CAL001);
        else if(!CALSGN)
           CAL = 10.*CAL100+1.*CAL010+0.1*CAL001;
        //printf("Cal Factor = %.1fdB\n", CAL);
        printf("Power = %.3f uW\n", 1000000.*(countvalue*2.*RMAX/59576.)*pow(10,CAL/10));

	ftdi_usb_close(ftdi);
	ftdi_free(ftdi);

	return 0;
}


























































